/* join.rexx */

/*
     Format

       JOIN [FILES] <file1> <file2> [...<fileN>] AS <fileAS>

   a 'front end' for join. Fixes a problem with join.

*/

signal on failure; signal off error; signal on syntax; signal on break_c
options failat 10
call addlib 'rexxextra.library',-20,-30,0

facility = 'Join'
dtemplate = 'FILES/...,AS=TO/A'
template = 'AS=TO/R,FILES/L'
args. = ''

parse arg g_c
do while g_c='?'
  options prompt dtemplate': '  /* this template is      */
  parse pull g_c		/* displayed to the user */
  if g_c='?' then do
    g_s=sourceline(3)
    if pos('/*',g_s)=0 then break; if pos('*/',g_s)>0 then break
    say
    g_s=sourceline(4)
    do i=5 while pos('*/',g_s)=0; say g_s; g_s=sourceline(i); end
    say
    end
  end
interpret Cparse(g_c,template,'args')
if args.ERRCODE > 1 then do; say facility'-E-BADARGS,' args.ERRTEXT; exit 5; end

program = 'c:Join'
temp = 't:JOIN.' || Pragma('ID')

c = ''
do i = 1 to args.FILES.0
  c = c||' '||args.FILES.i
  end
''program || c 'AS' temp
retcode = rc
'Move' temp args.AS
retcode = max(rc,retcode)
GetOut:
exit retcode

break_c:
break_d:
break_e:
break_f:
  say facility'-E-BREAK, Control-C interrupt'; retcode = 20; signal GetOut
failure:
  say facility'-E-FAIL, Line:' sigl', Error:' rc; retcode = rc; signal GetOut
syntax:
  say facility'-E-SYNTAX, Line:' sigl', Error:' rc; retcode = rc; signal GetOut
error:
  say facility'-E-ERROR, Line:' sigl', Error:' rc; retcode = rc; signal GetOut

