/******************************************************************************/
/*                                                                            */
/*                            YTReFormat                                      */
/*                 Copyright 1997 by Dick Whiting                            */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/* This script requires YAMTOOLS for it to work. If you don't have YAMTOOLS   */
/* you can get it on Aminet in directory comm/mail. This script allows you    */
/* to rewrap a mail file. I FINALLY got tired of doing it the hard way.       */
/* I would have liked to make it automatic, but just couldn't see how.        */
/* The current version will make all the quoting the same or remove it.       */
/* If you have any ideas for additional reformatting, contact me.             */
/*----------------------------------------------------------------------------*/
/* To use this select a mail and adjust the outer and inner quoting when      */
/* prompted. The outer quoting should be the character(s) or possibly none    */
/* that prefix the piece of lines that got wrapped badly. The inner quoting   */
/* should be the remainder (or none) necessary to make the lines uniform.     */
/* Sorry, if that is unclear. Play with it using the UNDO/REDO to figure      */
/* out how to make it work.                                                   */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/* Standard Disclaimer: I wrote it, it works for me, I don't guarantee        */
/* that it will do anything productive for anyone else, etc. etc. ;-)         */
/*                                                                            */
/*HOWEVER, if you DO find a use for it: I homeschool my kids and they         */
/*would love a postcard from where EVER you live.                             */
/*                                                                            */
/*Instant GEOGRAPHY lesson;)                                                  */
/*                                                                            */
/*                                                                            */
/*POSTCARDS:    Dick Whiting                                                  */
/*              28590 S. Beavercreek Rd.                                      */
/*              Mulino, Oregon 97042                                          */
/*              USA                                                           */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*               Address Bug Reports or Comments to:                          */
/*                Dick Whiting <dwhiting@europa.com>                          */
/*                           15 June 1997                                     */
/*                                                                            */
/******************************************************************************/
/*
$VER: 1.0 Copyright 1997 by Dick Whiting
$AUTHOR: Dick Whiting
$DESCRIPTION: Re-Format a mail file - needs YAMTOOLS
*/

options results
options failat 21

wrapparm=''
parse arg mainparm subparm

/**************************************************************************/
/*                         Initialize Variables                           */
/**************************************************************************/
Call MUIvars                                /* go define vars for MUI use */
Call YTvars                                 /* various values used in YT  */
Call Helpvars                               /* pointers into HELP guide   */
Call Localize                               /* vars for localizing strings*/
Call Builtvars                              /* built using previous values*/

Address YAMTOOLS

Call CheckYam

Select
   when mainparm='' then do
      Call CheckDup
      Call GetYamInfo
      Call ReadMail
   end
   when mainparm='DONE' then do
      Call SaveFile   
      Call Quit
   end
   when mainparm='SAVE' then do
      Call SaveFile   
   end
   when mainparm='REWRAP' | mainparm='UNQUOTE' then do
      Call AskUser
   end
   when mainparm='DOREWRAP' | mainparm='DOUNQUOTE' then do
      Call ValidateUser
      Call WrapBlock
   end
   when mainparm='STYLE' then do
      Call Stylelines
   end
   when mainparm='UNDO' then do
      Call Undo
   end
   when mainparm='REDO' then do
      Call Redo
   end
   when mainparm='QUIT' then do
      Call Quit
   end
   otherwise do
      errmsg=_text._badparm
      Call ErrorMsg
   end
end 

exit

/**************************************************************************/
/*                        Read the mail file into array                   */
/**************************************************************************/
ReadMail:     

	header.=' '

   i=0
   header=TRUE
   if open('IN',mfile,'R') then do
      Call BuildWindow
      infotext=_text._procmail
      infobuttons=''
      showbusy=TRUE
      Call InfoWindow

      list ID YTRFT ATTRS MUIA_List_Quiet TRUE 
      list ID YTRFM ATTRS MUIA_List_Quiet TRUE 
      do until eof('IN')
         linein=readln('IN')
         if header then do
            list ID YTRFH INSERT POS MUIV_List_Insert_Bottom STRING '='linein
            if linein='' then do 
					header=FALSE
					do j=1 to 4
	               list ID YTRFT INSERT POS MUIV_List_Insert_Bottom,
							  STRING '='header.j
					end
				end
				select
	            when word(linein,1)='From:' then header.1=linein
	            when word(linein,1)='To:'   then header.2=linein
	            when word(linein,1)='Date:' then header.3=linein
	            when word(linein,1)='Subject:' then header.4=linein
					otherwise nop
				end
         end
         else do
            if ~eof('IN') then do
               linein=right(i,5,'0')||',='||linein
               list ID YTRFM INSERT POS MUIV_List_Insert_Bottom, 
                    ATTRS MUIA_List_Format '"WEIGHT=0 MAXWIDTH=0 MINWIDTH=0,"',
                    STRING linein
               i=i+1
            end
         end
      end
      foo=close('IN')
      list ID YTRFT ATTRS MUIA_List_Quiet FALSE
      list ID YTRFM ATTRS MUIA_List_Quiet FALSE
      window ID YTINF close
   end
   else do
      errmsg=_text._badmail
      Call ErrorMsg
      exit     
   end
   
Return

/**************************************************************************/
/*                        Save the mail file back                         */
/**************************************************************************/
SaveFile:     

   infotext=_text._savemail    
   infobuttons=''
   showbusy=TRUE
   Call InfoWindow

   text ID YTRFF
   mfile=result

   fstate=statef(mfile)                           /* file information     */
   fbytes=subword(fstate,2,1)                     /* length of file       */
   fdate=subword(fstate,5,1)                      /* internal date        */
   fmins=subword(fstate,6,1)                      /* minutes since midnite*/
   fticks=subword(fstate,7,1)                     /* ticks past minutes   */
   fcomm=subword(fstate,8)                        /* old comment          */

   fdate=date('E',fdate,'I')                      /* get date in ddmmyy   */
   fdate=translate(fdate,'-','/')                 /* convert / to -       */
   hh=fmins%60                                    /* get hours            */
   hh=right(hh,2,'0')                             /* force to 2 digits    */
   mm=fmins//60                                   /* get minutes          */
   mm=right(mm,2,'0')                             /* force to 2 digits    */
   ss=fticks%50                                   /* seconds              */
   ss=right(ss,2,'0')                             /* force it             */
   ftime=hh||':'||mm||':'||ss                     /* timestamp rebuilt    */

   if open('OUT',mfile,'W') then do
      list ID YTRFH ATTRS MUIA_List_Entries       /* process header recs  */
      mcnt=result
      do i=0 to mcnt-1   
         list ID YTRFH POS i
         lineout=result
         lineout=substr(lineout,2)                /* strip = sign         */
         foo=writeln('OUT',lineout)
      end
      list ID YTRFM ATTRS MUIA_List_Entries
      mcnt=result
      do i=0 to mcnt-1   
         list ID YTRFM POS i
         lineout=result
         lineout=substr(lineout,8)           /* strip number and = sign   */
         foo=writeln('OUT',lineout)
      end
      foo=close('OUT')
   end

   Address Command 'SetDate ' mfile fdate ftime

   window ID YTINF close
   
Return

/**************************************************************************/
/*                        Validate User Input                             */
/**************************************************************************/
ValidateUser:

   string ID RUSR1 
   OutQuote=result

   string ID RUSR2
   InnQuote=result

   string ID RUSR3
   WordWrap=result

   if ~datatype(WordWrap,'W') then do
      errmsg=_text._wwnotnum
      Call ErrorMsg
      exit     
   end

   wraplen=wordwrap-(length(OutQuote)+length(InnQuote))

   if WordWrap<wrapmin1 | WordWrap>wrapmax then do
      errmsg=_text._wwoutrange
      Call ErrorMsg
      exit     
   end

   if wraplen<wrapmin2 then do
      errmsg=_text._wwshort
      Call ErrorMsg
      exit     
   end

   window ID YTUSR close
   
Return

/**************************************************************************/
/*                        Do the actual wrapping                          */
/**************************************************************************/
WrapBlock:

   WWarray.=missing
   j=0

   startpos=0                            /* top of list for default       */

   list ID YTRFM ATTRS MUIA_List_Entries
   mcnt=result

   do i=0 to mcnt-1                      /* locate selected lines to wrap */
      list ID YTRFM 
      wstring=result
      if wstring='' then leave i
      j=substr(wstring,1,5)+0
      if startpos=0 then startpos=j      /* first line rewrapped          */
      WWarray.j=substr(wstring,8)        /* strip prefix stuff            */
   end

   if j=0 then do                        /* user didn't select any        */
      errmsg=_text._nolines          
      Call ErrorMsg
      exit     
   end

   if mainparm='DOREWRAP' then infotext=_text._dowrap
   else infotext=_text._dounquote
   infobuttons=''
   showbusy=TRUE
   Call InfoWindow

   foo=open('OLD','T:YTReForm.old','W')  /* files for undo/redo functions */
   foo=open('NEW','T:YTReForm.new','W')

   do i=0 to mcnt-1                      /* loop completely thru list     */
      list ID YTRFM POS i
      linein=result
      if WWarray.i=missing then do       /* not a rewrap line             */
         foo=writeln('OLD',linein)       /* save line to OLD file         */
         WWarray.i=substr(linein,8)      /* copy to new array             */
      end
      else do                            /* start of a block to rewrap    */
         tempstr=''                      /* init to null rewrap string    */
         do j=i to mcnt-1                /* loop thru the new array       */
            linein=WWarray.j             /* get highlighted string ?      */
            if linein=missing then leave j  /* block is complete          */
            WWarray.j=missing            /* clear the entry for now       */
            if OutQuote~='' then do
               if substr(linein,1,length(OutQuote))=OutQuote then do
                  linein=substr(linein,1+length(OutQuote))
               end
            end
            if InnQuote~='' then do
               if substr(linein,1,length(InnQuote))=InnQuote then do
                  linein=substr(linein,1+length(InnQuote))
               end
            end
            tempstr=tempstr||' '||linein /* unquoted text to rewrap       */
            list ID YTRFM POS j          /* keep copying to OLD           */
            linein=result
            foo=writeln('OLD',linein)    /* save line to OLD file         */
         end         
         tempstr=substr(tempstr,2)       /* trim extra blank from start   */
         outlines=0                      /* none processed yet            */

         do while length(tempstr)>0      /* the actual rewrapping!!!      */
            blankpos=pos(' ',tempstr)    /* FIRST blank in remaining      */
            select
               when length(tempstr)<wraplen then do
                 newstr=tempstr
                 tempstr=''
               end
               when blankpos=0 then do
                 newstr=tempstr
                 tempstr=''
               end
               when blankpos>wraplen then do
                  newstr=substr(tempstr,1,blankpos)
                  tempstr=substr(tempstr,blankpos+1)
               end
               otherwise do
                  newstr=substr(tempstr,1,lastpos(' ',substr(tempstr,1,wraplen)))
                  tempstr=substr(tempstr,1+lastpos(' ',substr(tempstr,1,wraplen)))
               end
            end
            if mainparm='DOREWRAP' then do  /* if rewrapping add prefix   */
               newstr=OutQuote||InnQuote||newstr
            end
            k=i+outlines                 /* new pointer for array         */
            WWarray.k=newstr             /* store the wrapped line        */
            outlines=outlines+1
         end
         i=j-1                           /* decrement for loop control    */
      end
   end


/**************************************************************************/
/*  Clear the list, reload with rewrapped lines, copy to NEW file.        */
/**************************************************************************/

   list ID YTRFM ATTRS MUIA_List_Entries
   mcnt=result

   list ID YTRFM ATTRS MUIA_List_Visible
   lastpos=result

   jumppos=lastpos+startpos-3
   if jumppos>mcnt-1 then jumppos=mcnt-1

   list ID YTRFM ATTRS MUIA_List_Quiet TRUE 

   method ID YTRFM MUIM_List_Clear

   j=0
   do i=0 to mcnt-1
      if wwarray.i=missing then iterate  /* a null entry - skip it        */
      lineout=right(j,5,'0')||',='||wwarray.i
      foo=writeln('NEW',lineout)         /* write to the redo file        */
      list ID YTRFM INSERT POS MUIV_List_Insert_Bottom STRING lineout
      j=j+1                              /* pointer for list              */
   end

   button ID YTRFU ATTRS MUIA_Disabled FALSE   /* unghost UNDO button     */
   button ID YTRFR ATTRS MUIA_Disabled TRUE    /* ghost REDO button       */
   
   list ID YTRFM ATTRS MUIA_List_Quiet FALSE

   method ID YTRFM MUIM_List_Jump jumppos      /* go to first rewrapped   */

   foo=close('OLD')                      /* close undo file               */
   foo=close('NEW')                      /* close redo file               */

   window ID YTINF close

Return

/**************************************************************************/
/*  Loop thru selected lines, display as list of words, style them.       */
/**************************************************************************/
StyleLines:



Return

/**************************************************************************/
/*  Clear the list, reload from the OLD file, set button ghosting.        */
/**************************************************************************/
UNDO:

   button ID YTRFU ATTRS MUIA_Disabled TRUE    /* ghost UNDO button       */

   if open('IN','T:YTReForm.old','R') then do
      infotext=_text._doredo
      infobuttons=''
      showbusy=TRUE
      Call InfoWindow

      list ID YTRFM ATTRS MUIA_List_Entries
      mcnt=result
      list ID YTRFM ATTRS MUIA_List_Quiet TRUE

      method ID YTRFM MUIM_List_Clear

      do until eof('IN')
         linein=readln('IN')
         if ~eof('IN') then do
            list ID YTRFM INSERT POS MUIV_List_Insert_Bottom STRING linein
         end
      end
      foo=close('IN')
      button ID YTRFR ATTRS MUIA_Disabled FALSE   /* unghost REDO button  */
      list ID YTRFM ATTRS MUIA_List_Quiet FALSE
      foo=close('OLD')                   /* close undo file               */
      window ID YTINF close
   end
   else do
      errmsg=_text._noundofile
      Call ErrorMsg
      exit
   end


Return

/**************************************************************************/
/*  Clear the list, reload from the NEW file, set button ghosting.        */
/**************************************************************************/
REDO:

   button ID YTRFR ATTRS MUIA_Disabled TRUE    /* ghost REDO button       */

   if open('IN','T:YTReForm.new','R') then do
      infotext=_text._doredo
      infobuttons=''
      showbusy=TRUE
      Call InfoWindow

      list ID YTRFM ATTRS MUIA_List_Entries
      mcnt=result
      list ID YTRFM ATTRS MUIA_List_Quiet TRUE

      method ID YTRFM MUIM_List_Clear

      list ID YTRFM ATTRS MUIA_List_Quiet FALSE
      list ID YTRFM ATTRS MUIA_List_Quiet TRUE
      do until eof('IN')
         linein=readln('IN')
         if ~eof('IN') then do
            list ID YTRFM INSERT POS MUIV_List_Insert_Bottom STRING linein
         end
      end
      foo=close('IN')
      button ID YTRFU ATTRS MUIA_Disabled FALSE   /* unghost UNDO button  */
      list ID YTRFM ATTRS MUIA_List_Quiet FALSE
      foo=close('OLD')                   /* close undo file               */
      window ID YTINF close
   end
   else do
      errmsg=_text._noredofile
      Call ErrorMsg
      exit
   end

Return

/**************************************************************************/
/*  Clear the list, reload from the NEW file, set button ghosting.        */
/**************************************************************************/
QUIT:

   if exists('T:YTReForm.new') then do
      Address Command "Delete T:YTReForm.new QUIET"
   end

   if exists('T:YTReForm.old') then do
      Address Command "Delete T:YTReForm.old QUIET"
   end

   window ID YTREW close

Return

/**************************************************************************/
/*              Make sure YAM  and YAMTOOLS are running. Show YAM.        */
/**************************************************************************/
CheckYAM:

   if ~show('p','YAMTOOLS') then do
      errmsg=_text._noyt
      say errmsg
      exit
   end

   if ~show('p','YAM') then do
      errmsg=_text._noyam
      Call ErrorMsg
      exit
   end

   Address YAM 'show'                       /* uniconify YAM's screen     */  

	Address YAM 'info SCREEN'                /* get YAM's screen           */
	screen=result
	if screen='' then screen='Workbench'

Return

/**************************************************************************/
/*              Make sure there isn't one running already.                */
/**************************************************************************/
CheckDup:

   list ID YTRFM ATTRS MUIA_List_Entries
   if result~='RESULT' then do
      errmsg=_text._secondrun
      Call ErrorMsg
      exit
   end

Return
/******************************************************************************/
/*  Get information from YAM config file                                      */
/******************************************************************************/
GetYamInfo:

   Address YAM 'getmailinfo file'           /* find which mail to rewrap  */
   mfile=result
   
   if mfile='' | mfile='RESULT' then do     /* no mail selected           */
      errmsg=_text._nomail
      Call ErrorMsg
      exit
   end

   WordWrap=''
   QuoteText=''

   if open('IN','YAM:.config','R') then do
      do until eof('IN')
         linein=readln('IN')
         parse var linein yamopt '=' yamval
         if upper(yamopt)='WORDWRAP' then do
            WordWrap=strip(yamval)
            leave
         end
      end
      foo=close('IN')
   end

   if WordWrap='' then WordWrap=76

Return

/******************************************************************************/
/*  Display ERROR message and EXIT.                                           */
/******************************************************************************/
ErrorMsg:

   window ID YTINF CLOSE

   request ID ERRM GADGETS  _text._ok errmsg

   exit

Return

/******************************************************************************/
/*  Display the mail in a list window.                                        */
/******************************************************************************/
BuildWindow:

   window ID YTREW TITLE _title._main,        
          COMMAND '"YTReFormat.rexx QUIT"',
          ATTRS MUIA_Window_PublicScreen screen

		group
         group HORIZ
   			text ID YTRFF HELP help.YTRFF NODE node.YTRFF LABEL mfile
            string ID QTEXT ATTRS MUIA_ShowMe FALSE CONTENT QuoteText
            LABEL _text._wordwrap
            string ID RWRAP HELP help.RWRAP NODE node.RWRAP, 
						 ATTRS MUIA_Weight 10 CONTENT WordWrap
         endgroup
         group ATTRS MUIA_VertWeight 25
            list ID YTRFH INSERT ATTRS MUIA_ShowMe FALSE
            list ID YTRFT HELP help.YTRFT NODE node.YTRFT INSERT
         endgroup
         group HORIZ ATTRS MUIA_VertWeight 300
            group
               list ID YTRFM HELP help.YTRFM NODE node.YTRFM INSERT,
               	  ATTRS MUIA_Listview_MultiSelect MUIV_Listview_MultiSelect_Shifted
            endgroup
            group ATTRS MUIA_HorizWeight 10
               button ID YTRFW COMMAND '"YTReFormat.rexx REWRAP"',
						    HELP help.YTRFW NODE node.YTRFW, 
							 LABEL _label._YTRFW
/*             button ID YTRFO COMMAND '"YTReFormat.rexx UNQUOTE"',  */
/*				    HELP help.YTRFO NODE node.YTRFO,                     */
/*                    LABEL _label._YTRFO                            */
               button ID YTRFY COMMAND '"YTReFormat.rexx STYLE"', 
						    HELP help.YTRFY NODE node.YTRFY, 
                      ATTRS MUIA_Disabled TRUE,
							 LABEL _label._YTRFY
               space  
            endgroup
         endgroup
         group HORIZ
            button ID YTRFD COMMAND '"YTReFormat.rexx DONE"',
					    HELP help.YTRFD NODE node.YTRFD, 
						 LABEL _label._YTRFD
            button ID YTRFU COMMAND '"YTReFormat.rexx UNDO"', 
					    HELP help.YTRFU NODE node.YTRFU, 
                   ATTRS MUIA_Disabled TRUE,
                   LABEL _label._YTRFU
            button ID YTRFS COMMAND '"YTReFormat.rexx SAVE"', 
					    HELP help.YTRFS NODE node.YTRFS, 
						 LABEL _label._YTRFS
            button ID YTRFR COMMAND '"YTReFormat.rexx REDO"',
					    HELP help.YTRFR NODE node.YTRFR, 
                   ATTRS MUIA_Disabled TRUE,
                   LABEL _label._YTRFR
            button ID YTRFQ COMMAND '"YTReFormat.rexx QUIT"',
					    HELP help.YTRFQ NODE node.YTRFQ, 
						 LABEL _label._YTRFQ
         endgroup
		endgroup

   endwindow

Return

/******************************************************************************/
/*  Display the mail in a list window.                                        */
/******************************************************************************/
AskUser:

   OutQuote=''
   InnQuote=''

   string ID RWRAP
   WordWrap=result

	Address YAM 'info SCREEN'                /* get YAM's screen           */
	screen=result
	if screen='' then screen='Workbench'

   window ID YTUSR TITLE _title._user,
          COMMAND '"window ID YTUSR close"' PORT YAMTOOLS,
          ATTRS MUIA_Window_PublicScreen screen

		group HORIZ
         group 
            LABEL DOUBLE _text._outquote
            LABEL DOUBLE _text._inquote
            LABEL DOUBLE _text._wraplen
         endgroup
         group 
            string ID RUSR1 HELP help.RUSR1 NODE node.RUSR1,
                   ATTRS MUIA_CycleChain TRUE, 
                   MUIA_String_AdvanceOnCR TRUE,        
                   CONTENT OutQuote
            string ID RUSR2 HELP help.RUSR2 NODE node.RUSR2,
                   ATTRS MUIA_CycleChain TRUE, 
                   MUIA_String_AdvanceOnCR TRUE,        
                   CONTENT InnQuote
            string ID RUSR3 HELP help.RUSR3 NODE node.RUSR3,
                   ATTRS MUIA_CycleChain TRUE, 
                   MUIA_String_AdvanceOnCR TRUE,        
                   MUIA_String_Accept numerics,
                   CONTENT WordWrap
         endgroup
      endgroup
      group HORIZ
         if mainparm='REWRAP' then do
            button COMMAND '"YTReFormat.rexx DOREWRAP"' LABEL _label._YTRFW
         end
         else do
            button COMMAND '"YTReFormat.rexx DOUNQUOTE"' LABEL _label._YTRFO
         end
         button COMMAND '"window ID YTUSR close"' PORT YAMTOOLS,
                LABEL _text._cancel
		endgroup

   endwindow

   window ID YTUSR ATTRS MUIA_Window_ActiveObject MUIV_Window_ActiveObject_Next

Return

/******************************************************************************/
/*  Simple information/error message window.                                  */
/******************************************************************************/
InfoWindow:

   window ID YTINF TITLE _title._info ATTRS MUIA_Window_PublicScreen screen,
          MUIA_Window_SizeGadget FALSE,
          MUIA_Window_DepthGadget FALSE

      group 
         group 
            text ID STEXT HELP help.STEXT  NODE node.STEXT LABEL infotext
         endgroup
         if showbusy then do
            group
               object CLASS '"Busy.mcc"' ATTRS MUIA_VertWeight 25
            endgroup
         end
         if infobuttons ~='' then do
            group HORIZ
               group 
                  space HORIZ 
               endgroup
               group 
                  radio ID SQUIT HELP help.SQUIT  NODE node.SQUIT LABELS infobuttons
               endgroup
               group 
                  space HORIZ 
               endgroup
            endgroup
         end
         else do
            group 
               space HORIZ 100
            endgroup
         end
      endgroup
   endwindow

Return

/******************************************************************************/
/*                      MUIREXX TAGS & VARIABLES                              */
/******************************************************************************/
Muivars:

MUIA_CycleChain =           0x80421ce7
MUIA_Disabled =             0x80423661
MUIA_HorizWeight =          0x80426db9
MUIA_List_Format =          0x80423c0a 
MUIA_List_Entries =         0x80421654 
MUIA_Listview_MultiSelect = 0x80427e08
MUIA_List_Quiet =           0x8042d8c7
MUIA_List_Visible =         0x8042191f
MUIA_Selected =             0x8042654b
MUIA_ShowMe =               0x80429ba8
MUIA_String_Accept =        0x8042e3e1
MUIA_VertWeight =           0x804298d0 
MUIA_Weight =               0x80421d1f 
MUIA_Window_ActiveObject =  0x80427925
MUIA_Window_DepthGadget  =  0x80421923
MUIA_Window_PublicScreen =  0x804278e4
MUIA_Window_SizeGadget  =   0x8042e33d
MUIA_String_AdvanceOnCR =   0x804226de
MUIA_Window_ActiveObject =  0x80427925

MUIM_List_Jump =            0x8042baab
MUIM_List_Clear =           0x8042ad89

TRUE=1
FALSE=0

MUIV_List_Insert_Active = -1
MUIV_List_Insert_Bottom = -3
MUIV_Listview_MultiSelect_Shifted = 2
MUIV_List_Remove_First =  0
MUIV_Window_ActiveObject_Next = -1

Return

/**************************************************************************/
/*           Various values used throughout the various routines          */
/**************************************************************************/
YTvars:

missing='.'

numerics='"=0123456789"'                    /* valid for numeric input    */

wrapmin1=30                                 /* arbitrary low value        */
wrapmin2=20                                 /* arbitrary low value        */
wrapmax=79                                  /* max with LF for text/plain */

Return

/**************************************************************************/
/*    Messages, text, etc. constructed using previously defined values    */
/**************************************************************************/
Builtvars:

Return

/**************************************************************************/
/*               Pointers into the YamTools.guide documentation           */
/**************************************************************************/
Helpvars:

node.QTEXT='7.3.'
node.RUSR1='7.3.'
node.RUSR2='7.3.'
node.RUSR3='7.3.'
node.RWRAP='7.3.'
node.SQUIT='7.3.'
node.STEXT='7.3.'
node.YTRFD='7.3.'
node.YTRFF='7.3.'
node.YTRFM='7.3.'
node.YTRFO='7.3.'
node.YTRFQ='7.3.'
node.YTRFR='7.3.'
node.YTRFS='7.3.'
node.YTRFT='7.3.'
node.YTRFU='7.3.'
node.YTRFW='7.3.'
node.YTRFY='7.3.'

Return

/**************************************************************************/
/*       Mui Gadgets, text, msgs, etc. used in YamTools                   */
/**************************************************************************/
Localize:

/*********************************/
/* Miscellaneous info strings    */
/*********************************/
_title._main='"YTReFormat v1.0"'            /* main screen title          */
_title._info='"YTreFormat Info"'            /* default title on infomsg   */
_title._user='"YTReFormat User Info"'       /* title for user info screen */

_text._ok='Ok'                              /* various OK buttons         */
_text._cancel='Cancel'                      /* LABEL for CANCEL button    */
_text._wordwrap='WordWrap'                  /* text for WordWrap field    */

_label._YTRFD='Done'                        /* label for DONE button      */
_label._YTRFU='UnDo'                        /* label for DONE button      */
_label._YTRFR='ReDo'                        /* label for DONE button      */
_label._YTRFS='Save'                        /* label for SAVE button      */
_label._YTRFQ='Quit'                        /* label for QUIT  button     */
_label._YTRFY='Style'                       /* label for STYLE button     */              
_label._YTRFO='UnQuote'                     /* label for UNQUOTE button   */
_label._YTRFW='ReWrap'                      /* label for REWRAP  button   */

_text._outquote='Outer Quoting:'         /* text for outer quoting prompt */
_text._inquote='Inner Quoting:'          /* text for inner quoting prompt */
_text._wraplen='Wrap Length:'            /* text for word wrap len prompt */

_text._doredo='Doing ReDo'                   /* doing redo message        */
_text._doundo='Doing UnDo'                   /* doing undo message        */
_text._dowrap='Doing ReWrapping'             /* doing ReWrapping message  */
_text._dounquote='Doing UnQuoting'           /* doing UnQuoting message   */
_text._savemail='Saving Mail File'           /* saving mailfile message   */
_text._procmail='Processing Mail for ReWrapping' /* processing mail msg   */

/*********************************/
/* Various error conditions      */
/*********************************/

_text._noyam='You need YAM running to use YAMTOOLS'    /* yam not running */
_text._noyt='You need YAMTOOLS running to use YTReFormat' /* no yamtools  */
_text._secondrun='You ALREADY have a YTReFormat started'  /* second run   */
_text._nomail='You need to select a mail file to use YTReFormat'

                                         /* not a valid file or not found */               
_text._badmail='Not a valid file selected for Rewrapping'

_text._noredofile='Unable to open REDO file'     /* bad redo file message */
_text._noundofile='Unable to open UNDO file'     /* bad undo file message */
_text._nolines='No lines selected for rewrapping' /* no lines selected    */

                  /* the word wrap is too short for the quoting requested */
_text._wwshort='Word Wrap length is too small for quoting requested'

                  /* word wrap length is out of valid range values        */
_text._wwoutrange='Word Wrap should be between 'wrapmin1 'and ' wrapmax

                  /* non-numeric value -- shouldn't actually happen       */
_text._wwnotnum='Word Wrap length must be a numeric value'

                  /* bad parm passed to program..should never happen      */
_text._badparm='Unrecognized parms passed to YTReFormat:'

/**************************************************************************/
/*           Help Messages to display with MUI bubble facility.           */
/*                                                                        */
/* Format is simple: help.ID where ID is the id specified on the MUI      */
/* object statement.                                                      */
/* Similar approach for accessing the .guide information using the NODE   */
/* option on the object statement.                                        */
/*                                                                        */
/**************************************************************************/

help.QTEXT='""'
help.RUSR1='"Outer-most Quoting Character(s)"'
help.RUSR2='"Inner Quoting Character(s)"'
help.RUSR3='"Word Wrap length to use"'
help.RWRAP='"Word Wrap value from Yam:.config"'
help.SQUIT=''
help.STEXT=''
help.YTRFD='"Save changes to YAM mail file and Quit"'
help.YTRFF='"Yam mail file"'
help.YTRFM='"Select lines to rewrap"'
help.YTRFO='"UnQuote the selected lines"'
help.YTRFQ='"Abandon changes since last save"'
help.YTRFR='"Undo previous Undo wordwrap action"'
help.YTRFS='"Save changes to YAM mail file"'
help.YTRFT='"Short Header of mail file"'
help.YTRFU='"Undo previous wordwrap action"'
help.YTRFW='"ReWrap the selected lines"'
help.YTRFY='"Style the selected lines"'

Return

